//
// Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
// Copyright (C) 2012-2013 - David Violeau
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
//
//

function [x,y,typ]=SIMM_IdealGearGen(job,arg1,arg2)
x=[];y=[];typ=[];
select job
  case 'set' then
    x=arg1;
    graphics=arg1.graphics;exprs=graphics.exprs;
    model=arg1.model;
    while %t do
        [ok,ratio,fixedframe,exprs]=...
        getvalue(['';'Ideal gear without inertia';''],...
        [' ratio [-] : Transmission ratio (flange_a.phi/flange_b.phi) ' ; ' Fixed frame (1 : Yes / 0 : No)'],...
        list('vec',1,'vec',1),exprs);

      if ~ok then break, end
      
      //test error syntax
      if fixedframe<>1 & fixedframe<>0 then
          message(_('Choose 1 or 0 in order to specify fixed frame or not'));
          ok = %f
      end
      
      //no error
      if ok then
          if fixedframe==1 then //fixed frame -> emf0
                mo=modelica();
                mo.model='Modelica.Mechanics.Rotational.IdealGear0';
                 mo.inputs=['flange_a'];
                 mo.outputs=['flange_b'];
                 mo.parameters=list(['ratio'],...
                                    list(ratio),...
                                    [0]);
                 model.equations=mo;
                 model.in=ones(size(mo.inputs,'*'),1);
                 model.out=ones(size(mo.outputs,'*'),1);
                 x=standard_define([2 2],model,exprs,list([],0));
                 x.graphics.in_implicit=['I'];
                 x.graphics.in_style=[RotInputStyle()];
                 x.graphics.out_implicit=['I'];
                 x.graphics.out_style=[RotOutputStyle()];
          else
                mo=modelica();
                mo.model='Modelica.Mechanics.Rotational.IdealGear';
                 mo.inputs=['flange_a'];
                 mo.outputs=['flange_b','bearing'];
                 mo.parameters=list(['ratio'],...
                                    list(ratio),...
                                    [0]);
                 model.equations=mo;
                 model.in=ones(size(mo.inputs,'*'),1);
                 model.out=ones(size(mo.outputs,'*'),1);
                 x=standard_define([2 2],model,exprs,list([],0));
                 x.graphics.in_implicit=['I'];
                 x.graphics.in_style=[RotInputStyle()];
                 x.graphics.out_implicit=['I','I'];
                 x.graphics.out_style=[RotOutputStyle(), RotOutputStyle()];
          end    
      end
      

      break
    end
  case 'define' then
    model=scicos_model();
    ratio=1;
    fixed=1;
    model.sim='';
    model.blocktype='c';
    model.dep_ut=[%t %f];
    mo=modelica();
      mo.model='Modelica.Mechanics.Rotational.IdealGear0';
      mo.inputs=['flange_a'];
      mo.outputs=['flange_b'];
      mo.parameters=list(['ratio'],...
                         list(ratio),...
                         [0]);
      model.equations=mo;
      model.in=ones(size(mo.inputs,'*'),1);
      model.out=ones(size(mo.outputs,'*'),1);
    exprs=[sci2exp(ratio);sci2exp(fixed)];
    gr_i=[];
      x=standard_define([2 2],model,exprs,list(gr_i,0));
      x.graphics.in_implicit=['I'];
      x.graphics.in_style=[RotInputStyle()];
      x.graphics.out_implicit=['I'];
      x.graphics.out_style=[RotOutputStyle()];
  end
endfunction
